filetype: javascript

detect:
    filename: "(\\.js$|\\.es[5678]?$)"
    header: "^#!.*/(env +)?node( |$)"

rules:
    - constant.number: "\\b[-+]?([1-9][0-9]*|0[0-7]*|0x[0-9a-fA-F]+)([uU][lL]?|[lL][uU]?)?\\b"
    - constant.number: "\\b[-+]?([0-9]+\\.[0-9]*|[0-9]*\\.[0-9]+)([EePp][+-]?[0-9]+)?[fFlL]?"
    - constant.number: "\\b[-+]?([0-9]+[EePp][+-]?[0-9]+)[fFlL]?"
    - identifier: "[A-Za-z_][A-Za-z0-9_]*[[:space:]]*[(]"
    - symbol.brackets: "(\\{|\\})"
    - symbol.brackets: "(\\(|\\))"
    - symbol.brackets: "(\\[|\\])"
    - symbol.brackets: "(\\{|\\})"
    - symbol.brackets: "(\\(|\\))"
    - symbol.brackets: "(\\[|\\])"
    - symbol.operator: "[-+/*=<>!~%?:&|]"
    - statement: "\\b(async|await|break|case|catch|const|continue|debugger|default|delete|do|else|export|finally)\\b"
    - statement: "\\b(for|function|class|extends|get|if|import|in|instanceof|let|new|return|set)\\b"
    - statement: "\\b(super|switch|this|throw|try|typeof|var|void|while|with|yield)\\b"
    # reserved but unassigned
    - error: "\\b(enum|implements|interface|package|private|protected|public)"
    - constant: "\\b(null|undefined|NaN)\\b"
    - constant: "\\b(true|false)\\b"
    - type: "\\b(Array|Boolean|Date|Enumerator|Error|Function|Math)\\b"
    - type: "\\b(Number|Object|RegExp|String)\\b"
    # - constant: "/[^*]([^/]|(\\\\/))*[^\\\\]/[gim]*"
    - constant: "\\\\[0-7][0-7]?[0-7]?|\\\\x[0-9a-fA-F]+|\\\\[bfnrt'\"\\?\\\\]"
    - comment: "^#!.*/(env +)?node( |$)"


    - constant.string:
        start: "\""
        end: "\""
        skip: "\\\\."
        rules:
            - constant.specialChar: "\\\\."

    - constant.string:
        start: "'"
        end: "'"
        skip: "\\\\."
        rules:
            - constant.specialChar: "\\\\."

    - constant.string:
        start: "`"
        end: "`"
        rules:
            - constant.specialChar: "\\\\."

    - comment:
        start: "//"
        end: "$"
        rules: []

    - comment:
        start: "/\\*"
        end: "\\*/"
        rules: []

